//////////////////////////////////////////////////////////////////////
// buffered write
//
// fill up a buffer, then write it

using namespace std;

#include <iostream>	/* needed by some compilers */
#include <unistd.h>		/* for write */
#include <string.h>		/* for memcpy */
#include <syslog.h>
#include "bufwrite.h"
#include "minmax.h"

bufwrite::bufwrite()
 : fd(-1), obs(0), buf(0)
{}

bufwrite::bufwrite(int const _fd, int const _obs){
  setup(_fd, _obs);
}

void bufwrite::setup(int const _fd, int const _obs){
  fd =_fd;
  obs = _obs;
  buf.resize(obs);
  copy_to = &buf[0];
  fence = copy_to + obs;
}

void bufwrite::Write(const void* data, const int nn){
  int tocopy(nn);		// how much we want to send
  unsigned char* copy_from((unsigned char*) data);
  while (tocopy) {		// while some remains to send
    int cancopy = min(tocopy, fence - copy_to);
    if (0) cerr << "cancopy " << cancopy
	  << " room " << fence - copy_to << endl;
    memcpy(copy_to, copy_from, cancopy);
    tocopy -= cancopy;
    copy_from += cancopy;		// send the rest later
    copy_to += cancopy;
    if (copy_to == fence) {
      copy_to = &buf[0];		// for next time, and for write
      int sts = write(fd, copy_to, obs);
      if (sts < 0) {
	syslog(LOG_ERR, "Write error on bufpipe: %m");
	sleep(10);		// or exit ???
      } else if (sts != obs) {
	syslog(LOG_ERR, "Short write on bufpipe: %d not %d",
		sts, obs);
	sleep(10);		// or exit ???
      }
    }
  }
}
