#ifndef GAUSS_H
#define GAUSS_H

#include <cmath>

double normDen(double const x, double const mean, double const stdev);
double normCum(double const x, double const mean, double const stdev);
double normHist(double const x, double const mean, double const stdev,
		const int nslots);
double normEntTest(double const x, double const mean, double const stdev);

double const ln2inv(1/log(2.0));
double const pi2e(.5 * log(2.0 * M_PI * M_E)/log(2.0));

inline double log2(double const foo){
  return log(foo) * ln2inv;
}

class entropy_digitized_gaussian{
public:
 double stot, ptot;
 int nterms;
 double directly;
// Default constructor:
 entropy_digitized_gaussian() : directly(4.) {}
 double operator()(double const sigq, int const more = 0);
 double direct(double const sigq, int const more = 0);
};

#endif /* GAUSS_H */
